Flecs: ecs_observer_desc_t Struct Reference
Description: A fast entity component system (ECS) for C & C++

| Flecs v4.0 A fast entity component system (ECS) for C & C++

Loading...
Searching...
No Matches
Public Attributes | List of all members
ecs_observer_desc_t Struct Reference
C API » Core » API types | C API » Core » Observers

Used with ecs_observer_init(). More...

`#include <flecs.h>`

## Public Attributes
int32_t | _canary
| Used for validity testing.
ecs_entity_t | entity
| Existing entity to associate with observer (optional)
ecs_query_desc_t | query
| Query for observer.
ecs_entity_t | events [(8)]
| Events to observe (OnAdd, OnRemove, OnSet)
bool | yield_existing
| When observer is created, generate events from existing data.
ecs_iter_action_t | callback
| Callback to invoke on an event, invoked when the observer matches.
ecs_run_action_t | run
| Callback invoked on an event.
void * | ctx
| User context to pass to callback.
ecs_ctx_free_t | ctx_free
| Callback to free ctx.
void * | callback_ctx
| Context associated with callback (for language bindings).
ecs_ctx_free_t | callback_ctx_free
| Callback to free callback ctx.
void * | run_ctx
| Context associated with run (for language bindings).
ecs_ctx_free_t | run_ctx_free
| Callback to free run ctx.
ecs_poly_t * | observable
| Observable with which to register the observer.
int32_t * | last_event_id
| Optional shared last event id for multiple observers.
int8_t | term_index_
| Used for internal purposes.
ecs_flags32_t | flags_

## Detailed Description

Used with ecs_observer_init().

Definition at line 1310 of file flecs.h.

## Member Data Documentation

## ◆ _canary

int32_t ecs_observer_desc_t::_canary

Used for validity testing.

Must be 0.

Definition at line 1312 of file flecs.h.

## ◆ callback

ecs_iter_action_t ecs_observer_desc_t::callback

Callback to invoke on an event, invoked when the observer matches.

Definition at line 1328 of file flecs.h.

## ◆ callback_ctx

void* ecs_observer_desc_t::callback_ctx

Context associated with callback (for language bindings).

Definition at line 1345 of file flecs.h.

## ◆ callback_ctx_free

ecs_ctx_free_t ecs_observer_desc_t::callback_ctx_free

Callback to free callback ctx.

Definition at line 1348 of file flecs.h.

## ◆ ctx

void* ecs_observer_desc_t::ctx

User context to pass to callback.

Definition at line 1339 of file flecs.h.

## ◆ ctx_free

ecs_ctx_free_t ecs_observer_desc_t::ctx_free

Callback to free ctx.

Definition at line 1342 of file flecs.h.

## ◆ entity

ecs_entity_t ecs_observer_desc_t::entity

Existing entity to associate with observer (optional)

Definition at line 1315 of file flecs.h.

## ◆ events

ecs_entity_t ecs_observer_desc_t::events[(8)]

Events to observe (OnAdd, OnRemove, OnSet)

Definition at line 1321 of file flecs.h.

## ◆ flags_

ecs_flags32_t ecs_observer_desc_t::flags_

Definition at line 1365 of file flecs.h.

## ◆ last_event_id

int32_t* ecs_observer_desc_t::last_event_id

Optional shared last event id for multiple observers.

Ensures only one of the observers with the shared id gets triggered for an event

Definition at line 1361 of file flecs.h.

## ◆ observable

ecs_poly_t* ecs_observer_desc_t::observable

Observable with which to register the observer.

Definition at line 1357 of file flecs.h.

## ◆ query

ecs_query_desc_t ecs_observer_desc_t::query

Query for observer.

Definition at line 1318 of file flecs.h.

## ◆ run

ecs_run_action_t ecs_observer_desc_t::run

Callback invoked on an event.

When left to NULL the default runner is used which matches the event with the observer's query, and calls 'callback' when it matches. A reason to override the run function is to improve performance, if there are more efficient way to test whether an event matches the observer than the general purpose query matcher.

Definition at line 1336 of file flecs.h.

## ◆ run_ctx

void* ecs_observer_desc_t::run_ctx

Context associated with run (for language bindings).

Definition at line 1351 of file flecs.h.

## ◆ run_ctx_free

ecs_ctx_free_t ecs_observer_desc_t::run_ctx_free

Callback to free run ctx.

Definition at line 1354 of file flecs.h.

## ◆ term_index_

int8_t ecs_observer_desc_t::term_index_

Used for internal purposes.

Definition at line 1364 of file flecs.h.

## ◆ yield_existing

bool ecs_observer_desc_t::yield_existing

When observer is created, generate events from existing data.

For example, EcsOnAdd `Position` would match all existing instances of `Position`.

Definition at line 1325 of file flecs.h.

The documentation for this struct was generated from the following file:

- include/flecs.h